<template>
  <div class="data-documentation">
    <div v-if="loader" class="data-documentation__loader">
      <ob-loader
          :width="10"
          :height="10"
          :duration="2"
      />
    </div>
    <div v-if="!loader" class="data-documentation__text">
      <b>Перечень документов</b>
      <p>Отметьте обязательные документы и их количество. Можете добавить комментарии</p>
    </div>
    <ob-table
        v-if="!loader"
        :columns="columns"
        :items="list_docs"
        :is-groups-opened="false"
        class="data-documentation__table"
    >
      <template v-slot:required_field="{ data }">
        <ob-checkbox
            v-model="data.item.required"
            property="required"
            @change="changeSetting(data.item)"
        />
      </template>
      <template v-slot:count_field="{ data }">
        <ObInput
            v-model="data.item.count"
            class="data-documentation__input"
            type="money:0"
            :isConvertMoney="false"
            @blur="changeSetting(data.item)"
            placeholder="0"
        />
      </template>
      <template v-slot:comment_field="{ data }">
        <ObInput
            v-model="data.item.comment"
            class="data-documentation__input"
            type="text"
            @blur="changeSetting(data.item)"
            placeholder="0"
        />
      </template>
    </ob-table>
  </div>
</template>

<script>
  import ObLoader from 'common-components/src/obComponents/obLoader';
  import ObTable from 'common-components/src/obComponents/obTable';
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox';
  import ObInput from "common-components/src/obComponents/obInput";
  import {mapGetters, mapActions} from 'vuex';

  export default {
    name: "DataPanel",
    components: {
      ObLoader,
      ObTable,
      ObCheckbox,
      ObInput
    },
    data() {
      return {
        columns: [
          {
            title: 'Обязателен',
            key: 'required',
            isEditColumn: true,
            exactWidth: '10%',
            valueType: 'BOOLEAN',
            slotName: 'required_field'
          },
          {
            title: 'Документ',
            key: 'name',
            isEditColumn: false,
            exactWidth: '40%'
          },

          {
            title: 'Кол-во',
            key: 'count',
            slotName: 'count_field'
          },
          {
            title: 'Комментарий',
            key: 'comment',
            slotName: 'comment_field'
          }
        ]
      }
    },
    computed: {
      ...mapGetters({
        list_docs: 'clicarSettings/list_docs',
        loader: 'clicarSettings/loader',
        userUuid: 'user/userUuid',
        tab: 'clicarSettings/tab',
        client_uuid: 'clicarSettings/client_uuid',
        answerByServer: 'clicarSettings/answerByServer'
      })
    },
    methods: {
      ...mapActions({
        saveSettingByCustomer: 'clicarSettings/saveSettingByCustomer',
        selectRowDocs: 'clicarSettings/selectRowDocs'
      }),
      changeSetting(setting) {
        if (this.tab === 'FOR_CLIENT' && this.client_uuid !== '') {
          this.saveSettingByCustomer(setting)
            .then(() => {
              this.$notification({
                type: `system_notification_${this.answerByServer}`,
                message: this.answerByServer === 'success' ? 'Услуга по клиенту изменена' : 'Не удается изменить услугу по клиенту'
              });
            })
        } else {
          this.selectRowDocs(setting)
            .then(() => {
              this.$notification({
                type: `system_notification_${this.answerByServer}`,
                message: this.answerByServer === 'success' ? 'Услуга изменена' : 'Не удается изменить услугу'
              });
            })
        }
      }
    }
  }
</script>

<style scoped lang="scss">
  .data-documentation {
    &__loader {
      display: flex;
      justify-content: center;
      align-items: center;
      height: 300px;
    }

    &__text {
      margin-bottom: 20px;

      b {
        font-size: 16px;
        line-height: 20px;
        letter-spacing: 0.4px;
        color: #191E32;
      }

      p {
        font-size: 14px;
        line-height: 18px;
        letter-spacing: 0.2px;
        color: #737682;
      }
    }
  }
</style>

<style lang="scss">
  .data-documentation__table {
    .ob-input-wrap.--theme-default {
      border: 1px solid $color-grey-border !important;
      box-shadow: inset 0px 3px 6px rgba(25, 30, 50, 0.1) !important;
      border-radius: 3px !important;
      height: 27px;

      input {
        font-size: 12px;
        &::placeholder {
          font-size: 12px;
          color: $color-text-base;
        }
      }
    }
  }
</style>